<?PHP
/**
 * 唯品会JIT拣货单任务(根据配置时间段执行)
 *
 * @author wangbiao@shopex.cn
 * @version 0.1
 */

class ome_autotask_timer_vopick
{
    /* 当前的执行时间 */
    public static $now;
    
    /* 执行的间隔时间 */
    const intervalTime = 3600;
    
    function __construct()
    {
        self::$now = time();
    }
    
    /**
     * 创建拣货单
     */
    public function process($params, &$error_msg='')
    {
        @set_time_limit(0);
        @ini_set('memory_limit','128M');
        ignore_user_abort(1);
        
        $shopObj       = app::get('ome')->model('shop');
        $purchaseObj   = app::get('purchase')->model('order');
        $pickObj       = app::get('purchase')->model('pick_bills');
        $pickLib       = kernel::single('purchase_purchase_pick');
        $setObj        = app::get('purchase')->model('setting');
        
        //执行点
        $hour    = date('H', self::$now);
        
        //有效的配置
        $tempData    = $setObj->getList('*', array());
        if(empty($tempData))
        {
            return false;
        }
        
        $sids    = array();
        foreach ($tempData as $key => $val)
        {
            //已开启自动审核并且设置了出库仓
            if($val['is_auto_combine'] && $val['branch_id'])
            {
                $exec_hour    = explode(',', $val['exec_hour']);
                
                if(in_array($hour, $exec_hour))
                {
                    $sids[]    = $val['sid'];
                }
            }
        }
        
        if(empty($sids))
        {
            return false;//没有配置匹配到当前的审核时间段
        }
        
        //获取配置的店铺列表
        $sql       = "SELECT * FROM sdb_purchase_setting_shop WHERE sid IN(". implode(',', $sids) .") GROUP BY shop_id";
        $tempData  = $shopObj->db->select($sql);
        
        $shop_ids    = array();
        if($tempData)
        {
            foreach ($tempData as $key => $val)
            {
                $shop_ids[]    = $val['shop_id'];
            }
        }
        if(empty($shop_ids))
        {
            return false;
        }
        
        
        //按店铺执行
        foreach ($shop_ids as $shop_id)
        {
            //PO单有未拣货数量&&档期进行中
            //$poList    = $purchaseObj->getList('po_id, po_bn, shop_id', array('shop_id'=>$shop_id, 'unpick_num|than'=>0, 'sell_et_time|lthan'=>time()), 0, -1);
            
            $sql = "SELECT po_id, po_bn, shop_id FROM sdb_purchase_order WHERE shop_id='". $shop_id ."' AND unpick_num>0 AND sell_et_time>". time();
            $poList = $purchaseObj->db->select($sql);
            if($poList)
            {
                //拣货单
                $po_nos    = array();
                foreach ($poList as $key => $val)
                {
                    //新建拣货单
                    $param  = array('po_no'=>$val['po_bn']);
                    $rsp    = kernel::single('erpapi_router_request')->set('shop', $shop_id)->purchase_createPick($param);
                    
                    if($rsp['rsp']=='succ' && $rsp['pick_info'])
                    {
                        $po_nos[]    = $val['po_bn'];
                    }
                }
                
                //拉取拣货单
                if($po_nos)
                {
                    $param     = array('po_no' => implode(',', $po_nos));
                    $rsp_data  = kernel::single('erpapi_router_request')->set('shop', $shop_id)->purchase_getPickList($param);
                    
                    //拉取拣货单明细
                    if($rsp_data['rsp'] == 'succ' && $rsp_data['po_list'])
                    {
                        foreach ($rsp_data['po_list'] as $pi_key => $pi_val)
                        {
                            //保存拣货单及拣货单明细
                            $result    = $pickLib->pullPickDetail($pi_val, $shop_id);
                        }
                    }
                }
            }
            
            //自动生成出库单
            $result    = $pickLib->auto_batch_create_stockout($shop_id);
        }
        
        //自动审核出库单
        $stockoutObj    = app::get('purchase')->model('pick_stockout_bills');
        $autoStockLib   = kernel::single('purchase_purchase_auto_stockout');
        
        $stockList      = $stockoutObj->getList('stockout_id', array('status'=>1, 'confirm_status'=>1, 'o_status'=>1), 0, -1);
        foreach ($stockList as $key => $val)
        {
            //初始化信息
            $error_msg    = '';
            $result       = $autoStockLib->_initStockoutIfo($val['stockout_id'], $error_msg);
            if(!$result)
            {
                continue;
            }
            
            //审核
            $result       = $autoStockLib->combine($error_msg);
        }
        
        return true;
    }
}